require 'aba_generator/version'
require 'ostruct'
require 'aba_generator/core_ext/symbol'
require 'aba_generator/fixed_width_generator'
require 'aba_generator/fixed_width/column'
require 'aba_generator/fixed_width/definition'
require 'aba_generator/fixed_width/generator'
require 'aba_generator/fixed_width/parser'
require 'aba_generator/fixed_width/section'
require 'aba_generator/header'
require 'aba_generator/row'
require 'aba_generator/balancing_line'
require 'aba_generator/footer'

module AbaGenerator
  class Error < StandardError; end
  
  def initialize(options = {})
    # OPTIONS
    # institution_code
    # user_name
    # user_id
    # description
    # source_bsb
    # source_account_number
    # remitter_name
    # include_balancing_line
    
    @options = options
    AbaGenerator::Definition.define_fixed_width(@options)

    results = {}

    # Define the Header
    results[:header] = AbaGenerator::Header.new(@options)
    results[:body] = []
  end

  def generate(records)
    AbaGenerator::Definition.define_fixed_width

    # Create totals
    total = 0

    # # Create the record rows
    # records.each do |p|
    #   results[:body] << {
    #     :record_type => 1,
    #     :bsb => p.bank_account.bsb_sep,
    #     :account_number => ('%9.9s' % p.bank_account.full_account_number),
    #     :txcode => 53,
    #     :amount => sprintf("%0.10d", (p.amount * 100).to_i),
    #     :account_name => p.bank_account.account_name.truncate(32, omission: '').upcase,
    #     :reference => "PRIZE #{p.prize.prize_number}",
    #     :source_bsb => @options[:source_bsb],
    #     :source_account_number => ('%9.9s' % @options[:source_account_number]),
    #     :remitter_name => @options[:remitter_name].truncate(16, omission: '')
    #   }
    #   total += p.amount
    # end

    # if @options[:include_balancing_line]
    #   results[:body] << {
    #     :record_type => 1,
    #     :bsb => @options[:source_bsb],
    #     :account_number => ('%9.9s' % @options[:source_account_number]),
    #     :txcode => 13,
    #     :amount => sprintf("%0.10d", (total*100).to_i),
    #     :account_name => @options[:remitter_name].truncate(16, omission: ''),
    #     :reference => @options[:description],
    #     :source_bsb => @options[:source_bsb],
    #     :source_account_number => ('%9.9s' % @options[:source_account_number]),
    #     :remitter_name => @options[:remitter_name].truncate(16, omission: '')
    #   }
    # end

    # # Create the footer, with totals
    # if @options[:include_balancing_line]
    #   results[:footer] = [{
    #     :record_type => 7,
    #     :bsb_filler => "999-999",
    #     :net_total => 0,
    #     :credit_total => sprintf("%0.10d", (total*100).to_i),
    #     :debit_total => sprintf("%0.10d", (total*100).to_i),
    #     :records_count => (records.count + 1)
    #   }]
    # else
    #   results[:footer] = [{
    #     :record_type => 7,
    #     :bsb_filler => "999-999",
    #     :net_total => sprintf("%0.10d", (total*100).to_i),
    #     :credit_total => sprintf("%0.10d", (total*100).to_i),
    #     :debit_total => 0,
    #     :records_count => records.count
    #   }]        
    # end

    # Render the output as a string
    FixedWidthGenerator.generate(:aba, results)

  end  

end
